## wesnoth-1.16 1.16.4

=== debian/changelog ===
wesnoth-1.16 (1:1.16.4-1) unstable; urgency=medium

  * New upstream stable release.

 -- Rhonda D'Vine <rhonda@debian.org>  Mon, 11 Jul 2022 15:25:23 +0200

wesnoth-1.16 (1:1.16.3-1) unstable; urgency=medium

  * New upstream stable release.

 -- Rhonda D'Vine <rhonda@debian.org>  Mon, 30 May 2022 13:59:03 +0200
