## wesnoth-1.16 1.16.8

=== debian/changelog ===
wesnoth-1.16 (1:1.16.8-1mx21+1) mx; urgency=medium

  * Rebuild for MX-21.

 -- Mike Purtell <mmikeinsantarosa@mxlinux.org>  Fri, 24 Feb 2023 20:14:39 -0800

wesnoth-1.16 (1:1.16.8-1~bpo11+2) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.
  * Drop --no-trim argument for dh_installchangelogs (not supported by
    debhelper in bullseye).

 -- Vincent Cheng <vcheng@debian.org>  Wed, 01 Feb 2023 11:37:26 -0800

wesnoth-1.16 (1:1.16.8-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Vincent Cheng <vcheng@debian.org>  Tue, 31 Jan 2023 18:50:33 -0800

wesnoth-1.16 (1:1.16.8-1) unstable; urgency=medium

  * New upstream stable release.

 -- Vincent Cheng <vcheng@debian.org>  Sun, 22 Jan 2023 21:50:03 -0800

wesnoth-1.16 (1:1.16.7-2) unstable; urgency=medium

  * Add an autopkgtest to simulate running an AI-only wesnoth game.
  * Drop obsolete dependency on lsb-base for wesnoth-1.16-server.
  * Add Multi-Arch: foreign to wesnoth-1.16-tools.
  * Add Rules-Requires-Root: no to d/control.

 -- Vincent Cheng <vcheng@debian.org>  Sun, 22 Jan 2023 11:22:34 -0800

wesnoth-1.16 (1:1.16.7-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.
  * Workaround an internal compiler error specific to the version of GCC 10 in
    use in Debian bullseye, by compiling wesnoth with GCC 9 instead. (#980429)

 -- Vincent Cheng <vcheng@debian.org>  Sun, 22 Jan 2023 10:12:20 -0800

wesnoth-1.16 (1:1.16.7-1) unstable; urgency=medium

  * New upstream stable release.
  * Update obsolete build-dep (libfreetype6-dev -> libfreetype-dev).

 -- Vincent Cheng <vcheng@debian.org>  Mon, 16 Jan 2023 18:08:09 -0800

wesnoth-1.16 (1:1.16.6-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Vincent Cheng <vcheng@debian.org>  Thu, 05 Jan 2023 13:03:51 -0800

wesnoth-1.16 (1:1.16.6-1) unstable; urgency=medium

  * New upstream stable release.
    - Fixes crashes in multiplayer games. (Closes: #1025478)
  * Bump Standards-Version to 4.6.2, no changes needed.

 -- Vincent Cheng <vcheng@debian.org>  Tue, 03 Jan 2023 23:52:17 -0800
