=== debian/changelog ===
wesnoth-1.16 (1:1.16.9-1) unstable; urgency=medium

  * New upstream stable release.

 -- Vincent Cheng <vcheng@debian.org>  Thu, 20 Apr 2023 10:04:23 -0700
