=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: wesnoth-1.16
 Section: games
 Priority: optional
-Maintainer: Mike Purtell <mmikeinsantarosa@mxlinux.org>
-XSBC-Original-Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
+Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
 Build-Depends: debhelper-compat (= 13), libsdl2-image-dev (>= 2.0.0),
   libfreetype-dev, libsdl2-mixer-dev (>= 2.0.0), libfribidi-dev,
   libsdl2-ttf-dev (>= 2.0.8), libsdl2-dev (>= 2.0.4), libdbus-1-dev,
@@ -10,7 +9,7 @@
   libboost-serialization-dev, libboost-system-dev, libboost-thread-dev,
   libboost-program-options-dev, libboost-filesystem-dev, libboost-locale-dev,
   libboost-random-dev, libboost-coroutine-dev, libpng-dev, libreadline-dev,
-  libssl-dev, libpango1.0-dev, libvorbis-dev, cmake (>= 2.6), gcc-9, g++-9
+  libssl-dev, libpango1.0-dev, libvorbis-dev, cmake (>= 2.6)
 Standards-Version: 4.6.2
 Uploaders: Rhonda D'Vine <rhonda@debian.org>,
   Vincent Cheng <vcheng@debian.org>
@@ -245,3 +244,4 @@
 Architecture: all
 Description: "The Eastern Invasion" official campaign for Wesnoth (branch 1.16)
  This package contains the "The Eastern Invasion" campaign for Wesnoth:
+ "There are rumors of undead attacks on the eastern border of Wesnoth. You, an
