=== debian/rules ===
--- 
+++ 
@@ -22,12 +22,6 @@
 ifneq (,$(filter $(DEB_HOST_ARCH), mips mipsel))
     CXXFLAGSDBG = -g1
 endif
-
-# Workaround an internal compiler error specific to the version of GCC 10 in
-# use in Debian bullseye, by compiling wesnoth with GCC 9 instead.
-# https://bugs.debian.org/980429
-export CC       := /usr/bin/gcc-9
-export CXX      := /usr/bin/g++-9
 
 export CPPFLAGS := $(shell dpkg-buildflags --get CPPFLAGS) -I/usr/include/wolfssl -DOPENSSL_ALL
 export CFLAGS   := $(shell dpkg-buildflags --get CFLAGS) $(CPPFLAGS) -std=c11 -fopenmp
@@ -121,7 +115,7 @@
 binary-common:
 	dh_testdir
 	dh_testroot
-	dh_installchangelogs changelog.md
+	dh_installchangelogs --no-trim changelog.md
 	dh_installdocs
 	dh_installexamples
 	dh_installmenu
@@ -129,7 +123,7 @@
 	dh_installinit
 	dh_installsystemd --no-start --no-enable
 	dh_installman
-	dh_strip -a --no-automatic-dbgsym
+	dh_strip
 	dh_compress
 	dh_fixperms
 	dh_makeshlibs
@@ -184,3 +178,9 @@
 	# move the manpages to their proper name
 	for i in debian/wesnoth-$(BRANCH_VERSION)-core/usr/share/man/man6/wesnoth.6 \
 		debian/wesnoth-$(BRANCH_VERSION)-core/usr/share/man/*/man6/wesnoth.6; do \
+		mv $$i $$(echo $$i | sed -e 's/wesnoth\.6/wesnoth-$(BRANCH_VERSION).6/'); \
+		done
+	for i in debian/wesnoth-$(BRANCH_VERSION)-server/usr/share/man/man6/wesnothd.6 \
+		debian/wesnoth-$(BRANCH_VERSION)-server/usr/share/man/*/man6/wesnothd.6; do \
+		mv $$i $$(echo $$i | sed -e 's/wesnothd\.6/wesnothd-$(BRANCH_VERSION).6/'); \
+		done
